# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""

from Mapa_PU.widok.informacja_dialog import InformacjaDialog
from Mapa_PU.model.baza_danych import Baza
from Mapa_PU.model.informacja_model import InformacjaModel
from PyQt5.QtCore import QObject, pyqtSlot
from PyQt5.QtWidgets import QLineEdit
from Mapa_PU.kontroler import komunikaty

    
class Informacja(QObject):  
    """Obsługa informacji o nazdzorze"""
    def __init__(self,konfiguracja):
        self.konfiguracja=konfiguracja
        if self.konfiguracja.plikBazaTaksator:
            self.baza = Baza(self.konfiguracja.plikBazaTaksator)
            self.qdialog = InformacjaDialog()
            self.qdialog.informacja = self
            self.model = InformacjaModel()
                        
    def __del__(self):
        if isinstance(self.baza,Baza): 
            self.baza.zamknijPolaczenie()
   
    def pobierzInformacje(self,nazwa_tabeli,kolumny):
        """ Ładuje informacje z bazy danych do modelu (self.model.info & self.model.infodct). """
            
        if self.baza.polaczenie:          
            if  nazwa_tabeli and kolumny:
                kursor = self.baza.zwrocKursor()
                kursor.execute("SELECT " + ','.join(kolumny) + " FROM " + nazwa_tabeli)
                self.model.setInfo(kursor.fetchone())
                kursor.close()
    
    def zapiszInformacje(self):
        """ Zapis danych z modelu do bazy. Metoda pełni funkcję slotu dla klawisza 'Zapisz' """
        if self.baza.polaczenie:        
            self.zapiszModel()
            for pole,wartosc in self.model.infodct.items():
                self.baza.wykonajZapytanieModyfikacja("UPDATE " + self.model.nazwa_tabeli + " SET "+pole+"='"+wartosc+"'")        
            
                   
    def zapiszModel(self):
        """ Ładuje wartosci z dialogu do modelu (atrybut self.model.infodct) """
        if self.model.info:            
            for child in self.qdialog.findChildren(QLineEdit):
                if child.objectName() and child.objectName() in self.model.info._asdict():
                    self.model.infodct.update({ child.objectName() : child.text() }) 
                    
    def odczytajModel(self):
        """ Ładuje wartosci pól z modelu (atrybut self.info) do widoku . """
        if self.model.info and self.qdialog:
            for child in self.qdialog.findChildren(QLineEdit):
                if child.objectName() and child.objectName() in self.model.info._asdict():
                    child.setText(getattr(self.model.info,child.objectName()))

                   
    def run(self):
        
        _nazwa_tabeli = self.model.nazwa_tabeli
        _kolumny = self.model.kolumny
        
        if _nazwa_tabeli and _kolumny:
            
            self.baza.polaczOdbc()
            
            if self.baza.polaczenie:
                 
                if self.baza.czyIstniejeTabela(_nazwa_tabeli):
                    
                    if self.baza.liczbaWierszy("F_PARAMETER"):
        
                        # wypełnia dialog widgetami.
                        self.qdialog.fillQDialog()
        
                        # odczyt z bazy.
                        self.pobierzInformacje(_nazwa_tabeli,_kolumny)
        
                        # wypelnienie kontrolek danymi z modelu.
                        self.odczytajModel()
                
                        self.qdialog.exec_()
        
                    else:
                        komunikaty.blad(u'Informacje', u'Nie można edytować danych o nadzorze, ponieważ w bazie brakuje informacji o obiekcie. Uzupełnij je za pomocą programu Taksator - Plany uproszczone.')
                else:
                    komunikaty.blad(u'Informacje',u'Tabela F_PARAMETER nie istnieje !!!')
                    
                self.baza.zamknijPolaczenie()
                
            else:
                komunikaty.blad(u'Informacje',u'Brak połączenia z bazą danych.')

